<template>
  <div class="row no-gutters tour-button">
      <div class="col-sm-12  col-md-4">
          Vous souhaitez simuler :
          <b-button style="margin-left: 0.5rem" id="popup-tour" class="btn btn-popup">?</b-button>
          <b-popover ref="popover" target="popup-tour" triggers="focus">
              Cliquez sur le tour que vous souhaitez simuler il apparaîtra sur fond noir.
          </b-popover>

      </div>
      <div class="col-sm-12 col-md-7">
          <div class="tour-button-container">
            <ul
              class="toggle-switch"
              :class="{'square' : defaultOptions.layout.squareCorners}"
              :style="toggleSwitchStyle"
            >
              <li
                :style="itemStyle"
                v-for="(label, index) in defaultOptions.items.labels"
                :key="index"
              >
                <input
                  :disabled="defaultOptions.items.disabled || disabled"
                  :id="label.name + group" :value="label.value"
                  :name="name"
                  type="radio"
                  v-on:click="toggle"
                >
                <label
                  v-if="label.value == selectedItem"
                  :style="labelStyleSelected(label.color, label.backgroundColor)"
                  :class="{ active: !defaultOptions.items.disabled || disabled}"
                  class="selected"
                  :for="label.name + group"
                  type="radio"
                >
                  {{ label.name }}
                </label>
                <label
                  v-else
                  :style="labelStyle"
                  :class="{active: !defaultOptions.items.disabled || disabled}"
                  :for="label.name + group"
                  type="radio"
                >
                  {{ label.name }}
                </label>
              </li>
            </ul>
        </div>
    </div>
  </div>
</template>

<script>
const s = x => x + 's'
const rem = v => v + 'rem'

export default {
  name: 'ToggleSwitch',
  props: {
    options: {
      type: Object,
      required: false
    },
    value: {
      type: Number,
      required: false
    },
    name: {
      type: String,
      required: false
    },
    group: {
      type: String,
      required: false,
      default: ''
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  created () {
    this.defaultOptions = {
      layout: {
        color: 'black',
        backgroundColor: 'white',
        selectedColor: 'white',
        selectedBackgroundColor: 'green',
        fontFamily: 'Arial',
        fontWeight: 'normal',
        fontWeightSelected: 'bold',
        squareCorners: false,
        noBorder: false
      },
      size: {
        // fontSize: 1.5,
        padding: 0.3
      },
      items: {
        delay: 0.4,
        preSelected: 'unknown',
        disabled: false,
        labels: [
          { name: 'Premier tour', value: 0, color: 'white', backgroundColor: 'black' },
          { name: 'Deuxième Tour', value: 1, color: 'white', backgroundColor: 'black' }
        ]
      }
    }
  },
  mounted () {
    if (this.options !== null && this.options !== undefined) {
      this.mergeDefaultOptionsWithProp(this.options)
    }
    if (this.defaultOptions.items.preSelected !== 'unknown') {
      this.selectedItem = this.defaultOptions.items.preSelected
      this.$emit('input', this.selectedItem)
  } else if (typeof this.value == 'number') {
      this.selectedItem = this.value;
      this.$emit('input', this.selectedItem)
    }
  },
  data () {
    return {
      selected: false,
      selectedItem: 'unknown',
      defaultOptions: Object
    }
  },
  computed: {
    toggleSwitchStyle () {
      return {}
    },
    itemStyle () {
      return {
        fontFamily: this.defaultOptions.layout.fontFamily,
        // fontSize: rem(this.defaultOptions.size.fontSize),
        textAlign: 'center'
      }
    },
    labelStyle () {
      return {
        padding: rem(this.defaultOptions.size.padding),
        backgroundColor: this.defaultOptions.layout.backgroundColor,
        color: this.defaultOptions.layout.color,
        fontWeight: this.defaultOptions.layout.fontWeight,
        transition: s(this.defaultOptions.items.delay)
      }
    }
  },
  methods: {
    toggle (event) {
      if (!this.defaultOptions.items.disabled) {
        this.selected = true
        this.selectedItem = event.target.value;
        this.$emit('selected', this.selected)
        this.$emit('input', this.selectedItem)
        this.$emit('change', Number.parseInt(event.target.value) )
      }
    },
    labelStyleSelected (color, backgroundColor) {
      return {
        padding: rem(this.defaultOptions.size.padding),
        fontWeight: this.defaultOptions.layout.fontWeightSelected,
        backgroundColor: backgroundColor !== undefined ? backgroundColor : this.defaultOptions.layout.selectedBackgroundColor,
        color: color !== undefined ? color : this.defaultOptions.layout.selectedColor,
        transition: s(this.defaultOptions.items.delay)
      }
    },
    mergeDefaultOptionsWithProp (options) {
      var result = this.defaultOptions
      for (var option in options) {
        if (options[option] !== null && typeof (options[option]) === 'object') {
          for (var subOption in options[option]) {
            if (options[option][subOption] !== undefined && options[option][subOption] !== null) {
              result[option][subOption] = options[option][subOption]
            }
          }
        } else {
          result[option] = options[option]
        }
      }
    }
  },
  watch: {
    value (val) {
      this.selectedItem = val
    },
    options (val) {
      if (val !== null && val !== undefined) {
        this.mergeDefaultOptionsWithProp(val)
      }
    }
  }
}
</script>

<style lang="scss" scoped>
ul {
  list-style: none;
  padding: 0.1rem!important;
  border: 1px solid #dadada!important;
}

label {
  margin: 0;
}

.toggle-switch {
  display: inline-flex;

  padding: 0;
  margin: 0;

  width: 100%;

  border: 1px solid;

  border-top-left-radius: 50px;
  border-bottom-left-radius: 50px;

  border-top-right-radius: 50px;
  border-bottom-right-radius: 50px;

  background: white;
}

.square li:first-child label {
  border-top-left-radius: 0 !important;
  border-bottom-left-radius: 0 !important;
}
.square li:last-child label {
  border-top-right-radius: 0 !important;
  border-bottom-right-radius: 0 !important;
}

.toggle-switch li {
  position:relative;
  height: 2rem;
  width: 50%;

}


@media screen and (max-width: 308px){
    .tour-button {
        padding-top: .5rem;
        padding: .3rem!important;
    }
    .toggle-switch {
        margin-top: .5rem;
    }
    .toggle-switch li {
        width: 8rem;
    }
}

@media screen and (min-width: 1024px){
    // .toggle-switch li {
    //     width: 12rem;
    // }
}


.toggle-switch li:first-child label {
  border-top-left-radius: 50px;
  border-bottom-left-radius: 50px;
  border-top-right-radius: 50px;
  border-bottom-right-radius: 50px;
}

.toggle-switch li:last-child label {
  border-top-left-radius: 50px;
  border-bottom-left-radius: 50px;
  border-top-right-radius: 50px;
  border-bottom-right-radius: 50px;
}

.toggle-switch label, .toggle-switch input {
  display:block;
  position:absolute;
  top:0;
  left:0;
  right:0;
  bottom:0;
}

.toggle-switch input[type="radio"] {
  opacity:0.01;
  z-index:100;
}

.toggle-switch li:not(:first-child):not(:last-child) label {
  border-right: 1px solid;
  border-top: 1px solid;
  border-bottom: 1px solid;
}

.active {
  cursor: pointer;
}

</style>
